SystemOrganization addCategory: #'Twitter-Bootstrap-Magritte'!

MAReport subclass: #TWBSMagritteReport
	instanceVariableNames: 'showStriped showBordered showCondensed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteReport methodsFor: 'private-batch' stamp: 'JanVanDeSandt 3/22/2012 17:23'!
batchPageRangeEnd
	^ self batchMaxPages min: self batchPage + 5! !

!TWBSMagritteReport methodsFor: 'private-batch' stamp: 'JanVanDeSandt 3/22/2012 17:23'!
batchPageRangeStart
	^ self defaultBatchPage max: self batchPage - 5! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'JanVanDeSandt 3/22/2012 16:59'!
renderBatchDisabledItem: aString on: html

	html listItem 
		class: 'disabled'; 
		with: [
			html anchor
				url: '#' ;
				with: aString ]! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'JanVanDeSandt 3/22/2012 16:37'!
renderBatchDivOn: html

	html div
		class: 'pagination' ;
		with: [
			html unorderedList: [
				self showBatchFirstLast
					ifTrue: [ self renderBatchFirstOn: html ].
				self showBatchPreviousNext
					ifTrue: [ self renderBatchPreviousOn: html ].
				self showBatchPages
					ifTrue: [ self renderBatchItemsOn: html ].
				self showBatchPreviousNext
					ifTrue: [ self renderBatchNextOn: html ].
				self showBatchFirstLast
					ifTrue: [ self renderBatchLastOn: html ] ] ]! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'JanVanDeSandt 3/22/2012 17:39'!
renderBatchFirstOn: html

	html listItem
		class: 'disabled' if: self isOnFirstPage ;
		with: [
			self isOnFirstPage 
				ifFalse: [ html anchor callback: [ self batchPage: self defaultBatchPage ]; with: [ html twbsIcon: ' icon-fast-backward' ] ]
				ifTrue: [ html anchor url: '#'; with: [ html twbsIcon: ' icon-fast-backward' ] ] ]! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'JanVanDeSandt 3/22/2012 17:48'!
renderBatchItemsOn: html
	self batchPageRangeStart > self defaultBatchPage
		ifTrue: [ self renderBatchDisabledItem: '...' on: html ].
	self batchPageRange do: [ :index |
		html listItem
			class: 'active' if: (self batchPage = index) ;
			with: [
				self batchPage = index
					ifFalse: [ html anchor callback: [ self batchPage: index ]; with: index ]
					ifTrue: [ html anchor url: '#'; with: index ] ] ].
	self batchPageRangeEnd < (self batchMaxPages - 1)
		ifTrue: [ self renderBatchDisabledItem: '...' on: html ].
		
	(self showBatchFirstLast or: [ self batchPageRangeEnd = self batchMaxPages ])
		ifFalse: [
			html listItem: [
				html anchor
					callback: [ self batchPage: self batchMaxPages ];
					with: self batchMaxPages ] ]! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'JanVanDeSandt 3/22/2012 17:46'!
renderBatchLastOn: html

	html listItem
		class: 'disabled' if: self isOnLastPage ;
		with: [
			self isOnLastPage
				ifFalse: [ html anchor callback: [ self batchPage: self batchMaxPages ]; with: [ html twbsIcon: 'icon-fast-forward' ] ]
				ifTrue: [ html anchor url: '#'; with: [ html twbsIcon: 'icon-fast-forward' ] ] ]! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'JanVanDeSandt 3/22/2012 17:16'!
renderBatchNextOn: html

	html listItem
		class: 'disabled' if: self isOnLastPage ;
		with: [
			self isOnLastPage
				ifFalse: [ html anchor callback: [ self nextPage ]; with: [ html twbsIcon: 'icon-forward' ] ]
				ifTrue: [ html anchor url: '#'; with: [ html twbsIcon: 'icon-forward' ] ] ]! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'JanVanDeSandt 3/22/2012 17:17'!
renderBatchPreviousOn: html

	html listItem
		class: 'disabled' if: self isOnFirstPage ;
		with: [
			self isOnFirstPage 
				ifFalse: [ html anchor callback: [ self previousPage ]; with: [ html twbsIcon: 'icon-backward' ] ]
				ifTrue: [ html anchor url: '#'; with: [html twbsIcon: 'icon-backward' ] ] ]! !

!TWBSMagritteReport methodsFor: 'rendering' stamp: 'JanVanDeSandt 3/22/2012 16:28'!
renderContentOn: html
	html table
		id: self ajaxId; class: self tableClass;
		with: [ self renderTableOn: html ]! !

!TWBSMagritteReport methodsFor: 'rendering' stamp: 'JanVanDeSandt 3/22/2012 16:37'!
renderTableBatchOn: html
	self hasMoreThanOnePage ifTrue: [
		html tableRow: [
			html tableData
				class: 'batch';
				colSpan: self visibleColumns size;
				with: [
					self renderBatchDivOn: html ] ] ]! !

!TWBSMagritteReport methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 16:25'!
showBordered
	^ showBordered ifNil: [ false ]! !

!TWBSMagritteReport methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 16:25'!
showBordered: anObject
	showBordered := anObject! !

!TWBSMagritteReport methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 16:25'!
showCondensed
	^ showCondensed ifNil: [ false ]! !

!TWBSMagritteReport methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 16:25'!
showCondensed: anObject
	showCondensed := anObject! !

!TWBSMagritteReport methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 16:25'!
showStriped
	^ showStriped ifNil: [ false ]! !

!TWBSMagritteReport methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 16:25'!
showStriped: anObject
	showStriped := anObject! !

!TWBSMagritteReport methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 16:28'!
tableClass

	| classes |
	
	classes := OrderedCollection with: 'report' with: 'table'.
	self showBordered 
		ifTrue: [ classes add: 'table-bordered' ].
	self showStriped 
		ifTrue: [ classes add: 'table-striped' ].
	self showCondensed 
		ifTrue: [ classes add: 'table-condensed' ].

	^ classes reduce: [ :a :b | a , ' ' , b ]! !

MAFormDecoration subclass: #TWBSMagritteFormDecoration
	instanceVariableNames: 'formCss legend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteFormDecoration class methodsFor: 'instance creation' stamp: 'NickAger 3/19/2012 21:07'!
newWithDefaultButtons
	^ self new 
		addButtons: #(save cancel);
		yourself! !

!TWBSMagritteFormDecoration methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 15:35'!
formCss
	^ formCss! !

!TWBSMagritteFormDecoration methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 15:35'!
formCss: anObject
	formCss := anObject! !

!TWBSMagritteFormDecoration methodsFor: 'accessing' stamp: 'NickAger 3/21/2012 17:39'!
legend
	^ legend! !

!TWBSMagritteFormDecoration methodsFor: 'accessing' stamp: 'NickAger 3/21/2012 17:39'!
legend: anObject
	legend := anObject! !

!TWBSMagritteFormDecoration methodsFor: 'rendering' stamp: 'NickAger 3/19/2012 15:43'!
renderButtonsOn: html
	html div 
		class: 'form-actions'; 
		class: self formCss;
		with: [
			self buttons 
				do: [ :each |
					html button
						accessKey: each value first;
						class: 'btn';
						class: 'btn-primary' if: (each = buttons first);
						callback: [ self execute: each key ];
						text: each value ]
				separatedBy: [ html text: ' ' ] ]! !

!TWBSMagritteFormDecoration methodsFor: 'rendering' stamp: 'NickAger 3/21/2012 17:40'!
renderContentOn: html
	html form
		class: 'magritte';
		class: self formCss;
		multipart: self requiresMultipartForm;
		defaultAction: [ self execute: self default ];
		with: [
			html fieldSet: [
				self renderLegendOn: html.
				self renderNextOn: html.
				self renderButtonsOn: html ] ]! !

!TWBSMagritteFormDecoration methodsFor: 'rendering' stamp: 'NickAger 3/21/2012 17:41'!
renderLegendOn: html
	self legend notNil ifTrue: [
		html legend: self legend ]! !

!MAContainer methodsFor: '*twitter-bootstrap-magritte' stamp: 'NickAger 3/22/2012 11:00'!
twbsFormInline
	^ self propertyAt: #twbsFormInline ifAbsent: [ false ]! !

!MAContainer methodsFor: '*twitter-bootstrap-magritte' stamp: 'NickAger 3/22/2012 11:01'!
twbsFormInline: aBoolean
	self propertyAt: #twbsFormInline put: aBoolean! !

!MAContainer methodsFor: '*twitter-bootstrap-magritte' stamp: 'NickAger 3/22/2012 10:59'!
twbsInlineValidationMessages
	^ self propertyAt: #twbsInlineValidationMessages ifAbsent: [ true ]! !

!MAContainer methodsFor: '*twitter-bootstrap-magritte' stamp: 'NickAger 3/22/2012 11:00'!
twbsInlineValidationMessages: aBoolean
	self propertyAt: #twbsInlineValidationMessages put: aBoolean! !

MACheckboxComponent subclass: #TWBSMagritteCheckboxComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteCheckboxComponent methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 09:21'!
renderEditorOn: html
	html label
		class: 'checkbox';
		with: [
			html checkbox
				id: self labelId;
				disabled: self isReadonly;
				on: #value of: self.
			html space; render: self magritteDescription checkboxLabel ]! !

MAValidationDecoration subclass: #TWBSMagritteValidationDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteValidationDecoration methodsFor: 'rendering' stamp: 'NickAger 3/21/2012 18:17'!
renderErrorsOn: html
	html break.
		
	html div
		class: 'alert';
		class: 'alert-error';
		with: [
			html anchor 
				class: 'close';
				attributeAt: 'data-dismiss' put: 'alert';
				with: [ html html: '&#215;' ].

			html strong: 'Please correct the following issues:'.
			html unorderedList
				class: 'errors';
				list: self errors;
				with: nil ]! !

!MAElementDescription methodsFor: '*twitter-bootstrap-magritte' stamp: 'NickAger 3/10/2012 01:00'!
placeholder
	^ self 
		propertyAt: #placeholder 
		ifAbsent: [ nil ]! !

!MAElementDescription methodsFor: '*twitter-bootstrap-magritte' stamp: 'NickAger 3/10/2012 01:01'!
placeholder: placeHolderText
	^ self propertyAt: #placeholder put: placeHolderText! !

MAComponentRenderer subclass: #TWBSMagritteFormRenderer
	instanceVariableNames: 'validationMessagesInline formInline'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteFormRenderer methodsFor: 'error handling' stamp: 'NickAger 3/9/2012 22:32'!
errorsForDescription: aDescription 
	^ component errors select: [ :anError | anError tag = aDescription ]! !

!TWBSMagritteFormRenderer methodsFor: 'accessing' stamp: 'NickAger 3/22/2012 11:07'!
formInline
	^ formInline ifNil: [ formInline := false ]! !

!TWBSMagritteFormRenderer methodsFor: 'accessing' stamp: 'NickAger 3/22/2012 11:07'!
formInline: anObject
	formInline := anObject! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/20/2012 13:34'!
renderComment:  aDescription
	aDescription comment notNil ifTrue: [
		html span
			class: 'help-inline';
			with: [
				html html: aDescription comment ] ]! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 11:13'!
renderContainer: aDescription
	self validationMessagesInline: aDescription twbsInlineValidationMessages.
	self formInline: aDescription twbsFormInline.
	self formInline ifTrue: [ html break ].
	
	super renderContainer: aDescription! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/19/2012 13:40'!
renderControl: aDescription
	html render: (self childAt: aDescription)! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 11:09'!
renderElement: aDescription
	aDescription group = group
		ifFalse: [ self renderGroup: aDescription ].
		
	self formInline 
		ifTrue: [ self renderElementForInlineForm: aDescription ]
		ifFalse: [ 
			html div
				class: 'control-group';
				class: (self classFor: aDescription);
				with: [
					self renderLabel: aDescription.
					html div
						class: 'controls';
						 with: [ 			
							self renderControl: aDescription.
							self renderComment: aDescription.
							self validationMessagesInline ifTrue: [ self renderErrorSpan: aDescription ] ] ] ]! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 11:33'!
renderElementForInlineForm: aDescription
	html span
		class: 'control-group';
		class: (self classFor: aDescription);
		with: [
			self renderLabel: aDescription.
			html space.
			html span
				class: 'controls';
				 with: [ 			
					self renderControl: aDescription.
					html space.
					self renderComment: aDescription.
					self validationMessagesInline ifTrue: [  html space. self renderErrorSpan: aDescription ] ].
			html space ]! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/10/2012 00:10'!
renderErrorSpan: aDescription
	(self errorsForDescription: aDescription) do: [ :error |
		html span 
			class: 'help-inline';
			with: error ]! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 11:12'!
renderLabel: aDescription
	| label |
	aDescription hasLabel ifFalse: [ ^ self ].
	label := html label class: 'control-label'.
	(self childAt: aDescription) hasLabelId
		ifTrue: [ label for: (self childAt: aDescription) labelId ].
	label with: [ html html: aDescription label ]! !

!TWBSMagritteFormRenderer methodsFor: 'accessing' stamp: 'NickAger 3/20/2012 13:30'!
validationMessagesInline
	^ validationMessagesInline ifNil: [ validationMessagesInline := true ]! !

!TWBSMagritteFormRenderer methodsFor: 'accessing' stamp: 'NickAger 3/20/2012 13:30'!
validationMessagesInline: anObject
	validationMessagesInline := anObject! !

MATextInputComponent subclass: #TWBSMagritteTextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteTextInputComponent methodsFor: 'rendering' stamp: 'NickAger 3/19/2012 13:42'!
renderInputOn: html
	| textInput |
	textInput := html textInput.
	description placeholder notNil ifTrue: [ 
		textInput twbsPlaceholderText: description placeholder ].	
		
	textInput
		id: self labelId;
		on: #string of: self.! !

MARadioGroupComponent subclass: #TWBSMagritteRadioGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteRadioGroupComponent class methodsFor: 'testing' stamp: 'NickAger 3/20/2012 11:37'!
isAbstract
	^ false! !

!TWBSMagritteRadioGroupComponent methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 10:47'!
renderEditorOn: html
	| group |
	group := html radioGroup.
	html span
		id: self labelId;
		with: [
			self optionsWithIndexDo: [ :each :index |
				self renderOption: each
					index: index
					in: group
					on: html ]
				separatedBy: [ ] ]! !

!TWBSMagritteRadioGroupComponent methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 09:22'!
renderOption: anObject index: anInteger in: aRadioGroup on: html
	| optionId |
	optionId := self optionId: anInteger.
	html label
		class: 'radio';
		with: [
			html radioButton
				id: optionId;
				group: aRadioGroup;
				selected: self value = anObject;
				callback: [ self value: anObject ].
			html space.
			html text: (self labelForOption: anObject) ].


! !
